# TodoList

- [x] 控制器逻辑
  - [x] 设置数据源
    - [x] 网络
      - [x] 设置请求头
    - [x] 本地
    - [x] 资产
  - [x] 播放
  - [x] 暂停
  - [x] 停止
  - [x] 释放资源
  - [x] 控制音量
  - [ ] 监听播放完成
  - [x] 控制系统音量
    - [x] 修复 iOS 系统音量与逻辑相反的问题
    - [x] 修复 iOS 系统音量出现系统弹窗的问题
    - [x] 修复 iOS 系统音量出现时视频明显卡顿的问题
  - [x] 获取视频信息
    - [x] 宽高
    - [x] 当前播放进度
    - [x] 总时长
    - [x] 视频方向
    - [x] 视频播放速度
      - [x] tcp 速度
    - [ ] 当前视频编解码器(作为未来备选方案,目前 android 端可获取,iOS 端只有解码器 id 没有名字)
      - [ ] 视频
      - [ ] 音频
    - [x] 帧数
      - [x] android
      - [ ] iOS (目前永远是 0,获取的是 GL_view 的 fps)
  - [x] 控制亮度
    - [x] 逻辑方法
    - [x] 界面实现
  - [x] 屏幕方向锁定 : 这个指当前页面支持什么方向的应用
    - [ ] iPad 无效,暂不知原因
  - [x] 屏幕旋转: 这个指强制当前屏幕旋转至哪个方向
    - [ ] iPad 无效,暂不知原因
  - [x] 截图
  - [ ]  悬浮窗中播放
    - [ ] 悬浮窗的UI控制器
    - [ ] 自定义UI
- [x] 默认控制器 UI
  - [x] 进度条
  - [x] 播放/暂停按钮
  - [x] 全屏横向滑动进度
  - [x] 拖动进度条快速调节进度
    - [x] 逻辑部分实现
    - [x] UI 提示
  - [x] 纵向滑动音量
  - [x] 单击显示/隐藏界面
  - [x] 双击播放/暂停
  - [x] 使用选项切换音量的控制是系统音量还是资源音量
  - [x] 允许根据情况禁用各种控制手势
  - [x] 当一个视频是直播视频时,进度条应该隐藏,且无拖动进度相关手势
  - [x] 全屏切换
    - [x] UI(控制器 UI 内)
    - [x] android
    - [x] iOS
    - [x] 利用 ShowDialog 开发一个全屏的播放界面,不仅仅在 Example 中
      - [x] 根据屏幕宽高确定是横屏全屏还是竖屏全屏(比如:常规电影是横屏,常规自拍类视频为竖屏)
- [x] 根据视频角度自动旋转
- [x] 保证视频图像宽高比不失真
- [x] 允许自定义控制器 UI
- [ ] 未开始播放时的界面
  - [ ] 默认
  - [ ] 允许自定义
- [ ] 完善示例代码
  - [x] 播放网络
  - [x] 播放相册
  - [x] 播放 asset
  - [ ] 设置选项的使用
  - [x] 切换全屏播放的示例代码
  - [x] 在列表中(ListView)
  - [x] 视频竖向分页滑动
  - [x] 在悬浮窗中播放
    - [x] 悬浮窗的UI控制器
      - [ ] 允许自定义UI
- [x] iOS 部分视频无法显示图像的问题: 可能很长时间内都无法解决
